antiWinLoop <- false;
::hasRoundEnded <- false;

function EndRound(winner = null)
{
    if (!IsValidRound() || hasRoundEnded)
        return;
    hasRoundEnded <- true;
    if (!winner)
        winner = PlayerInstanceFromIndex(GetFirstPlace()[0]);

    winner.KeyValueFromString("targetname", "winner");

    local roundWin = SpawnEntityFromTable("game_round_win",
    {
        win_reason = "0",
        force_map_reset = "1", //not having
        TeamNum = "0",         //these 3 lines
        switch_teams = "0"     //causes the crash when trying to fire game_round_win
    });
    EntFireByHandle(roundWin, "SetTeam", ""+winner.GetTeam(), 0.1, null, null);
    EntFireByHandle(roundWin, "RoundWin", "", 0.1, null, null);
    return;
}

OnGameEvent("teamplay_win_panel", 0, function(params)
{
    if (!IsValidRound())
        return;
    local winner = Entities.FindByName(null, "winner");
    if (!IsValidPlayer(winner) || antiWinLoop)
        return;
    antiWinLoop = true;

    EmitSoundEx({
        sound_name = "player/taunt_bell.wav",
        volume = 1,
        sound_level = 150,
        filter_type = RECIPIENT_FILTER_GLOBAL
    });
    winner.AddCond(TF_COND_CRITBOOSTED);

    //Display scoreboard
    RunWithDelay(0, function() {
        local tabs = {
        	winning_team = 1
        };
        local firstPlace = GetFirstPlace();
        local firstPlaceEnt = PlayerInstanceFromIndex(firstPlace[0]);
        local secondPlace = GetSecondPlace();
        local secondPlaceEnt = PlayerInstanceFromIndex(secondPlace[0]);
        local thirdPlace = GetThirdPlace();
        local thirdPlaceEnt = PlayerInstanceFromIndex(thirdPlace[0]);
        if (firstPlaceEnt)
        {
            tabs.player_1 <- firstPlaceEnt.entindex()
            tabs.player_1_points <- firstPlace[1]
        }
        if (secondPlaceEnt)
        {
            tabs.player_2 <- secondPlaceEnt.entindex()
            tabs.player_2_points <- secondPlace[1]
        }
        if (thirdPlaceEnt)
        {
            tabs.player_3 <- thirdPlaceEnt.entindex()
            tabs.player_3_points <- thirdPlace[1]
        }
        SendGlobalGameEvent("teamplay_win_panel", tabs);
    });

    //Stun non-winners
    SpawnEntityFromTable("filter_activator_name", {
        Negated = 1,
        filtername = "winner",
        targetname = "filter_losers",
    });

    local triggerCatapult = SpawnEntityFromTable("trigger_stun", {
        move_speed_reduction = "0.6",
        origin = "0 0 0"
        spawnflags = 1,
        StartDisabled = 0,
        stun_type = 2
        stun_duration = 9999
        filtername = "filter_losers"
    })

    triggerCatapult.KeyValueFromInt("solid", 2)
    triggerCatapult.KeyValueFromString("mins", "-99999 -99999 -99999")
    triggerCatapult.KeyValueFromString("maxs", "99999 99999 99999")
});

function GetFirstPlace()
{
    local maxI = 0;
    local maxV = -1;
    for (local i = 1; i <= MAX_PLAYERS; i++)
    {
        local score = GetScoreByIndex(i);
        if (score >= maxV)
        {
            maxI = i;
            maxV = score;
        }
    }
    return [maxI, maxV];
}

function GetSecondPlace()
{
    local firstPlace = GetFirstPlace();
    local maxI = 0;
    local maxV = -1;
    for (local i = 1; i <= MAX_PLAYERS; i++)
    {
        local score = GetScoreByIndex(i);
        if (score >= maxV && i != firstPlace[0])
        {
            maxI = i;
            maxV = score;
        }
    }
    return [maxI, maxV];
}

function GetThirdPlace()
{
    local firstPlace = GetFirstPlace();
    local secondPlace = GetSecondPlace();
    local maxI = 0;
    local maxV = -1;
    for (local i = 1; i <= MAX_PLAYERS; i++)
    {
        local score = GetScoreByIndex(i);
        if (score >= maxV && i != firstPlace[0] && i != secondPlace[0])
        {
            maxI = i;
            maxV = score;
        }
    }
    return [maxI, maxV];
}

::GetScore <- function(player)
{
    return gunGameProgress[player.entindex()];
    /*local result = GetKills(player) + GetAssists(player) * 2.0 / 3.0;
    if (result >= fragLimit)
        result = fragLimit;
    return result;*/
    //GetPropIntArray(tf_player_manager, "m_iActiveDominations", 0, player.entindex())
    //return GetPropIntArray(tf_player_manager, "m_iTotalScore", player.entindex());
    //return GetPropInt(player, "m_Shared.tfsharedlocaldata.m_RoundScoreData.m_iKills");
}

::GetScoreByIndex <- function(entIndex)
{
    return gunGameProgress[entIndex];
    /*local result = kills[entIndex] + assists[entIndex] * 2.0 / 3.0;
    if (result >= fragLimit)
        result = fragLimit;
    return result;*/
    //GetPropIntArray(tf_player_manager, "m_iActiveDominations", 0, player.entindex())
    //return GetPropIntArray(tf_player_manager, "m_iTotalScore", player.entindex());
    //return GetPropInt(player, "m_Shared.tfsharedlocaldata.m_RoundScoreData.m_iKills");
}

::kills <- player_collection(0);
::assists <- player_collection(0);

::GetKills <- function(player)
{
    return kills[player.entindex()];
}

::GetAssists <- function(player)
{
    return assists[player.entindex()];
}

::kills2 <- player_collection(0);
::assists2 <- player_collection(0);

::GetKills2 <- function(player)
{
    return kills2[player.entindex()];
}

::GetAssists2 <- function(player)
{
    return assists2[player.entindex()];
}

::SetKills2 <-  function(player, kills)
{
    return kills2[player.entindex()] = kills;
}

::SetAssists2 <-  function(player, assists)
{
    assists2[player.entindex()] = assists;
}