IncludeScript("gungame/gungame/announcer.nut")
IncludeScript("gungame/gungame/weapon_list.nut")
IncludeScript("gungame/gungame/weapon_order.nut")
IncludeScript("gungame/gungame/scoreboard.nut")

::gunGameProgress <- player_collection(0);
::fragLimit <- 14;

OnGameEvent("player_death", 20, function(victim, params)
{
    if (!IsValidRound())
        return;
    local attacker = GetPlayerFromParams(params, "attacker");
    local assister = GetPlayerFromParams(params, "assister");

    if (attacker && attacker != victim)
    {
        local weaponTT = GetCurrentGunGameWeapon(attacker);
        local killsRequired = safeget(weaponTT, "gungame_kills", 1);
        if (GetKills2(attacker) >= killsRequired)
        {
            SetKills2(attacker, 0);
            SwitchToNextWeapon(attacker);
        }
    }
    if (assister && assister != victim)
    {
        local weaponTT = GetCurrentGunGameWeapon(assister);
        local assistsRequired = safeget(weaponTT, "gungame_kills", 1) == 2 ? 3 : 2;
        if (GetAssists2(assister) >= assistsRequired && weaponTT != GetWeaponTypeByName("golden_crowbar"))
        {
            SetAssists2(assister, 0);
            SwitchToNextWeapon(assister);
        }
    }
});

OnGameEvent("player_death", 0, function(player, params)
{
    if (!IsValidRound())
        return;
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker && attacker != player)
    {
        local particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red_shower",
            origin = attacker.GetCenter(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1, null, null);

        particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red",
            origin = attacker.GetOrigin(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1, null, null);

        local oldHealth = attacker.GetHealth();
        local newHealth = clampCeiling(oldHealth + 50, attacker.GetMaxHealth() + 50);
        attacker.SetHealth(newHealth);
        SendGlobalGameEvent("player_healonhit", {
            entindex = attacker.entindex(),
            amount = newHealth - oldHealth
        });
    }
});

function ConvertToMerc(player)
{
    if (!IsCustomCharacter(player))
        ConvertToCustomCharacter(player, "gungame/gungame/mercenary.nut");
}

function SwitchToNextWeapon(player)
{
    local progress = gunGameProgress[player.entindex()]++;
    if (progress >= fragLimit - 1)
    {
        EndRound(player);
        return;
    }

    FireCustomEvent("next_weapon", {
        "userid": player.GetUserID()
    });
    player.SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(player).names[0] + "_to_" + GetNextGunGameWeapon(player).names[0]);

    if ("SwitchToNextWeapon" in player.GetScriptScope())
        player.GetScriptScope().SwitchToNextWeapon();
}