//This way we avoid resetting the mp_timeleft timer when mp_restartgame_immediate happens
if (!GetPersistentVar("m_flMapResetTime", null))
    SetPersistentVar("m_flMapResetTime", GetPropFloat(tf_gamerules, "m_flMapResetTime"));
else
    SetPropFloat(tf_gamerules, "m_flMapResetTime", GetPersistentVar("m_flMapResetTime"));

::teamSwitch <- GetPersistentVar("team_switch", true);
::redTeamOnly <- GetPersistentVar("red_team_only", Convars.GetStr("tv_name") == "The Announcer");
if (redTeamOnly)
    Convars.SetValue("mp_humans_must_join_team", "red");
else
    Convars.SetValue("mp_humans_must_join_team", "any");

OnGameEvent("player_say", -999, function(player, params)
{
    local steamId = GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]")
        return;

    if (params.text.find("restart") == 1)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
    }

    if (params.text.find("team_switch") == 1 || params.text.find("teamswitch") == 1)
    {
        teamSwitch = !teamSwitch;
        SetPersistentVar("team_switch", teamSwitch);
    }

    if (params.text.find("noteam") == 1)
    {
        redTeamOnly = !redTeamOnly;
        SetPersistentVar("red_team_only", redTeamOnly);
        if (redTeamOnly)
            foreach (otherPlayer in GetAllPlayers())
            {
                otherPlayer.SwitchTeam(TF_TEAM_RED);
                otherPlayer.ForceRespawn();
            }
    }

    if (params.text.find("nogun") == 1)
    {
        SetPropEntity(player, "m_hActiveWeapon", null);
    }

    if (params.text.find("test") == 1)
    {
        for (local i = 0; i < 10; i++)
        {
            local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
            if (weaponEnt && weaponEnt.GetSlot() == 2)
            {
                player.Weapon_Switch(weaponEnt)
                return;
            }
        }
    }

    if (params.text.find("win") == 1)
    {
        AddScore(player, 2);
        EndRound(null);
    }

    if (params.text.find("start") == 1 || params.text.find("skip") == 1 || params.text.find("check") == 1)
    {
        local GameRules = Entities.FindByClassname(null, "tf_gamerules");
        local MAX_CLIENTS = MaxClients().tointeger();

        // 0 - not ready
        // 1 - ready
        local ready_state = 1;

        local red_check = false;
        local blue_check = false;

        for (local i = 1; i <= MAX_CLIENTS; i++)
        {
	        local player = PlayerInstanceFromIndex(i);
	        if (!player)
		        continue;

	        local team = player.GetTeam();
	        if (!(team & 2))
		        continue;

	        if (team == 2)
	        {
		        if (red_check)
			        continue;
		        red_check = true;
	        }
	        else if (team == 3)
	        {
		        if (blue_check)
			        continue;
		        blue_check = true;
	        }

	        if (NetProps.GetPropBoolArray(GameRules, "m_bTeamReady", team))
		        continue;

	        NetProps.SetPropBoolArray(GameRules, "m_bTeamReady", ready_state == 1, team);

	        SendGlobalGameEvent("tournament_stateupdate",
	        {
		        userid = player.entindex(),
		        readystate = ready_state,
		        namechange = 0,
		        oldname = " ",
		        newname = " ",
	        });

	        if (ready_state == 0)
	        {
		        NetProps.SetPropFloat(GameRules, "m_flRestartRoundTime", -1.0);
		        NetProps.SetPropBool(GameRules, "m_bAwaitingReadyRestart", true);
	        }
        }
    }

    if (params.text.find("noflame") == 1)
    {
        SetPersistentVar("no_flame", true);
    }

    if (params.text.find("next") == 1)
    {
        local arg = params.text.len() <= 6 ? "" : params.text.slice(6).tolower();
        if (arg == "" || arg == "self" || arg == "!self")
        {
            kills[player.entindex()] += 2;
            SwitchToNextWeapon(player);
        }
        else
        {
            foreach (otherPlayer in GetAllPlayers())
            {
                if (NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    kills[otherPlayer.entindex()] += 2;
                    SwitchToNextWeapon(otherPlayer);
                    break;
                }
            }
        }
    }

    if (params.text.find("piss") == 1)
    {
        foreach (otherPlayer in GetAllPlayers())
        {
            otherPlayer.AddCondEx(TF_COND_URINE, 5, otherPlayer);
        }
    }
    if (params.text.find("test") == 1)
    {
        //Stun non-winners
        SpawnEntityFromTable("filter_activator_name", {
            Negated = 1,
            filtername = "winner",
            targetname = "filter_losers",
        });

        local triggerCatapult = SpawnEntityFromTable("trigger_stun", {
            move_speed_reduction = "0.6",
            origin = "0 0 0"
            spawnflags = 1,
            StartDisabled = 0,
            stun_type = 2
            stun_duration = 99
        })

        triggerCatapult.KeyValueFromInt("solid", 2)
        triggerCatapult.KeyValueFromString("mins", "-99999 -99999 -99999")
        triggerCatapult.KeyValueFromString("maxs", "99999 99999 99999")
    }
});

AddTimer(3.0, 0, function ()
{
    local edicts = 0;
    for (local ent; ent = Entities.FindByClassname(ent, "*");)
        edicts++;

    if (edicts > 1950)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
        ClientPrint(null, HUD_PRINTTALK, "WARNING! Almost exceeded the entity limit! Emergency restart")
    }
});

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    PrintError(FindTheLizard(), e);
})

::PrintError <- function(player, e)
{
    printl(e)
    local Chat = @(m) ClientPrint(player, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(2))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
}